module     p0_dd_emnebardu_d57h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity0/d57h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d57
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd57h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      real(ki) :: t11
      real(ki) :: t12
      real(ki) :: t13
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      if(deg.eq.1) then
         numerator = (spvak1k2(iv1)*abb57n20+spvak2k1(iv1)*abb57n13+t1*abb57n19+&
         &t2*abb57n16)
         return
      end if
      t11 = d(iv1,iv2)
      t3 = spvak3k1(iv2)
      t4 = spvak3k2(iv2)
      t5 = spvak3k4(iv2)
      t6 = k1(iv2)
      t7 = spvak3k1(iv1)
      t8 = spvak3k2(iv1)
      t9 = spvak3k4(iv1)
      t10 = k2(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*t11*abb57n23+t1*t3*abb57n14+t1*t4*abb57n18+t1*t5*&
         &abb57n21+t10*t7*abb57n14+t10*t8*abb57n18+t10*t9*abb57n21+t2*t3*abb57n1&
         &4+t2*t4*abb57n18+t2*t5*abb57n21+t6*t7*abb57n14+t6*t8*abb57n18+t6*t9*ab&
         &b57n21)
         return
      end if
      t12 = d(iv2,iv3)
      t13 = d(iv1,iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t11*abb57n15+spvak3k2(iv3)*t11*abb&
         &57n17+spvak3k4(iv3)*t11*abb57n22+t12*t7*abb57n15+t12*t8*abb57n17+t12*t&
         &9*abb57n22+t13*t3*abb57n15+t13*t4*abb57n17+t13*t5*abb57n22))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d57:
   subroutine     reconstruct_d57(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_57:
      coeffs%coeffs_57%c0 = derivative(czip)
      coeffs%coeffs_57%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_57%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_57%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_57%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_57%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_57%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_57%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_57%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_57%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_57%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_57%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_57%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_57%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_57%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_57%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_57%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_57%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_57%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_57%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_57%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_57%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_57%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_57%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_57%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_57%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_57%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_57%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_57%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_57%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_57%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_57%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_57%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_57%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_57%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_57:
   end subroutine reconstruct_d57
!---#] subroutine reconstruct_d57:
end module p0_dd_emnebardu_d57h0l1d
