module     p0_dd_emnebardu_d58h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity0/d58h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d58
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd58h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      real(ki) :: t19
      real(ki) :: t20
      real(ki) :: t21
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = k6(iv1)
      t2 = spvak6k2(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb58n35+t2*abb58n19)
         return
      end if
      t3 = k1(iv1)
      t4 = spvak6k2(iv2)
      t5 = spvak6k4(iv2)
      t6 = k1(iv2)
      t7 = spvak6k4(iv1)
      t8 = k5(iv1)
      t9 = k5(iv2)
      t10 = spvak5k1(iv2)
      t11 = spvak5k2(iv2)
      t12 = k6(iv2)
      t13 = spvak5k1(iv1)
      t14 = spvak5k2(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak6k1(iv2)
      t17 = spvak3k4(iv2)
      t18 = spvak6k1(iv1)
      if(deg.eq.2) then
         numerator = (spvak5k4(iv1)*t4*abb58n24+spvak5k4(iv2)*t2*abb58n24+spvak5&
         &k6(iv1)*t4*abb58n26+spvak5k6(iv2)*t2*abb58n26+t1*t10*abb58n23+t1*t11*a&
         &bb58n27+t10*t2*abb58n21+t10*t7*abb58n22+t11*t7*abb58n25+t12*t13*abb58n&
         &23+t12*t14*abb58n27+t13*t4*abb58n21+t13*t5*abb58n22+t14*t5*abb58n25+t1&
         &5*t16*abb58n34+t17*t18*abb58n34+t2*t6*abb58n28+t2*t9*abb58n30+t3*t4*ab&
         &b58n28+t3*t5*abb58n33+t4*t8*abb58n30+t5*t8*abb58n31+t6*t7*abb58n33+t7*&
         &t9*abb58n31)
         return
      end if
      t19 = d(iv2,iv3)
      t20 = d(iv1,iv3)
      t21 = d(iv1,iv2)
      t1 = spvak6k1(iv3)
      t3 = spvak5k2(iv3)
      t6 = spvak3k4(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak6k2(iv3)*t21*abb58n29+spvak6k4(iv3)*t21*abb&
         &58n32+t19*t2*abb58n29+t19*t7*abb58n32+t20*t4*abb58n29+t20*t5*abb58n32)&
         &+t1*t11*t15*abb58n20+t1*t14*t17*abb58n20+t11*t18*t6*abb58n20+t14*t16*t&
         &6*abb58n20+t15*t16*t3*abb58n20+t17*t18*t3*abb58n20)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d58:
   subroutine     reconstruct_d58(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_58:
      coeffs%coeffs_58%c0 = derivative(czip)
      coeffs%coeffs_58%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_58%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_58%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_58%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_58%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_58%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_58%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_58%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_58%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_58%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_58%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_58%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_58%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_58%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_58%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_58%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_58%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_58%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_58%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_58%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_58%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_58%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_58%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_58%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_58%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_58%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_58%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_58%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_58%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_58%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_58%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_58%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_58:
   end subroutine reconstruct_d58
!---#] subroutine reconstruct_d58:
end module p0_dd_emnebardu_d58h0l1d
