module     p0_dd_emnebardu_d67h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity0/d67h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d67
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd67h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb67n15
         return
      end if
      t1 = spvak5k2(iv1)
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb67n19+spvak3k2(iv1)*abb67n22+spvak6k2(iv1)*abb6&
         &7n21+t1*abb67n18)
         return
      end if
      t2 = spvak5k2(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb67n20+k1(iv1)*t2*abb67n25+k1(iv2)*t&
         &1*abb67n25+k3(iv1)*t2*abb67n26+k3(iv2)*t1*abb67n26+k4(iv1)*t2*abb67n26&
         &+k4(iv2)*t1*abb67n26+spvak3k1(iv1)*t2*abb67n17+spvak3k1(iv2)*t1*abb67n&
         &17+spvak3k4(iv1)*t2*abb67n24+spvak3k4(iv2)*t1*abb67n24+spvak6k1(iv1)*t&
         &2*abb67n16+spvak6k1(iv2)*t1*abb67n16+spvak6k4(iv1)*t2*abb67n23+spvak6k&
         &4(iv2)*t1*abb67n23)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d67:
   subroutine     reconstruct_d67(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_67:
      coeffs%coeffs_67%c0 = derivative(czip)
      coeffs%coeffs_67%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_67%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_67%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_67%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_67%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_67%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_67%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_67%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_67%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_67%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_67%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_67%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_67%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_67%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_67:
   end subroutine reconstruct_d67
!---#] subroutine reconstruct_d67:
end module p0_dd_emnebardu_d67h0l1d
