module     p0_dd_emnebardu_golem95h0
   use precision_golem, only: ki_gol => ki
   use p0_dd_emnebardu_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
      module procedure reconstruct_group3
      module procedure reconstruct_group4
      module procedure reconstruct_group5
      module procedure reconstruct_group6
      module procedure reconstruct_group7
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use p0_dd_emnebardu_config
   use p0_dd_emnebardu_groups, only: tensrec_info_group0
   use p0_dd_emnebardu_d39h0l1, only: numerator_d39 => numerator_golem95
   use p0_dd_emnebardu_d39h0l1d, only: reconstruct_d39
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 39:
      if (tens_rec_by_derivatives) then
         call reconstruct_d39(coeffs)
      else
         call reconstruct2(numerator_d39, coeffs%coeffs_39)
      end if
   !------#] Diagram 39:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use p0_dd_emnebardu_config
   use p0_dd_emnebardu_groups, only: tensrec_info_group1
   use p0_dd_emnebardu_d23h0l1, only: numerator_d23 => numerator_golem95
   use p0_dd_emnebardu_d23h0l1d, only: reconstruct_d23
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 23:
      if (tens_rec_by_derivatives) then
         call reconstruct_d23(coeffs)
      else
         call reconstruct2(numerator_d23, coeffs%coeffs_23)
      end if
   !------#] Diagram 23:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use p0_dd_emnebardu_config
   use p0_dd_emnebardu_groups, only: tensrec_info_group2
   use p0_dd_emnebardu_d4h0l1, only: numerator_d4 => numerator_golem95
   use p0_dd_emnebardu_d4h0l1d, only: reconstruct_d4
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 4:
      if (tens_rec_by_derivatives) then
         call reconstruct_d4(coeffs)
      else
         call reconstruct3(numerator_d4, coeffs%coeffs_4)
      end if
   !------#] Diagram 4:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
!---#[ subroutine reconstruct_group3:
subroutine     reconstruct_group3(coeffs)
   use tens_rec
   use p0_dd_emnebardu_config
   use p0_dd_emnebardu_groups, only: tensrec_info_group3
   use p0_dd_emnebardu_d6h0l1, only: numerator_d6 => numerator_golem95
   use p0_dd_emnebardu_d6h0l1d, only: reconstruct_d6
   implicit none
   type(tensrec_info_group3), intent(out) :: coeffs
   !------#[ Diagram 6:
      if (tens_rec_by_derivatives) then
         call reconstruct_d6(coeffs)
      else
         call reconstruct3(numerator_d6, coeffs%coeffs_6)
      end if
   !------#] Diagram 6:
end subroutine reconstruct_group3
!---#] subroutine reconstruct_group3:
!---#[ subroutine reconstruct_group4:
subroutine     reconstruct_group4(coeffs)
   use tens_rec
   use p0_dd_emnebardu_config
   use p0_dd_emnebardu_groups, only: tensrec_info_group4
   use p0_dd_emnebardu_d3h0l1, only: numerator_d3 => numerator_golem95
   use p0_dd_emnebardu_d3h0l1d, only: reconstruct_d3
   use p0_dd_emnebardu_d58h0l1, only: numerator_d58 => numerator_golem95
   use p0_dd_emnebardu_d58h0l1d, only: reconstruct_d58
   use p0_dd_emnebardu_d59h0l1, only: numerator_d59 => numerator_golem95
   use p0_dd_emnebardu_d59h0l1d, only: reconstruct_d59
   implicit none
   type(tensrec_info_group4), intent(out) :: coeffs
   !------#[ Diagram 3:
      if (tens_rec_by_derivatives) then
         call reconstruct_d3(coeffs)
      else
         call reconstruct3(numerator_d3, coeffs%coeffs_3)
      end if
   !------#] Diagram 3:
   !------#[ Diagram 58:
      if (tens_rec_by_derivatives) then
         call reconstruct_d58(coeffs)
      else
         call reconstruct3(numerator_d58, coeffs%coeffs_58)
      end if
   !------#] Diagram 58:
   !------#[ Diagram 59:
      if (tens_rec_by_derivatives) then
         call reconstruct_d59(coeffs)
      else
         call reconstruct2(numerator_d59, coeffs%coeffs_59)
      end if
   !------#] Diagram 59:
end subroutine reconstruct_group4
!---#] subroutine reconstruct_group4:
!---#[ subroutine reconstruct_group5:
subroutine     reconstruct_group5(coeffs)
   use tens_rec
   use p0_dd_emnebardu_config
   use p0_dd_emnebardu_groups, only: tensrec_info_group5
   use p0_dd_emnebardu_d2h0l1, only: numerator_d2 => numerator_golem95
   use p0_dd_emnebardu_d2h0l1d, only: reconstruct_d2
   use p0_dd_emnebardu_d10h0l1, only: numerator_d10 => numerator_golem95
   use p0_dd_emnebardu_d10h0l1d, only: reconstruct_d10
   use p0_dd_emnebardu_d15h0l1, only: numerator_d15 => numerator_golem95
   use p0_dd_emnebardu_d15h0l1d, only: reconstruct_d15
   use p0_dd_emnebardu_d54h0l1, only: numerator_d54 => numerator_golem95
   use p0_dd_emnebardu_d54h0l1d, only: reconstruct_d54
   use p0_dd_emnebardu_d57h0l1, only: numerator_d57 => numerator_golem95
   use p0_dd_emnebardu_d57h0l1d, only: reconstruct_d57
   use p0_dd_emnebardu_d60h0l1, only: numerator_d60 => numerator_golem95
   use p0_dd_emnebardu_d60h0l1d, only: reconstruct_d60
   use p0_dd_emnebardu_d64h0l1, only: numerator_d64 => numerator_golem95
   use p0_dd_emnebardu_d64h0l1d, only: reconstruct_d64
   implicit none
   type(tensrec_info_group5), intent(out) :: coeffs
   !------#[ Diagram 2:
      if (tens_rec_by_derivatives) then
         call reconstruct_d2(coeffs)
      else
         call reconstruct3(numerator_d2, coeffs%coeffs_2)
      end if
   !------#] Diagram 2:
   !------#[ Diagram 10:
      if (tens_rec_by_derivatives) then
         call reconstruct_d10(coeffs)
      else
         call reconstruct2(numerator_d10, coeffs%coeffs_10)
      end if
   !------#] Diagram 10:
   !------#[ Diagram 15:
      if (tens_rec_by_derivatives) then
         call reconstruct_d15(coeffs)
      else
         call reconstruct2(numerator_d15, coeffs%coeffs_15)
      end if
   !------#] Diagram 15:
   !------#[ Diagram 54:
      if (tens_rec_by_derivatives) then
         call reconstruct_d54(coeffs)
      else
         call reconstruct1(numerator_d54, coeffs%coeffs_54)
      end if
   !------#] Diagram 54:
   !------#[ Diagram 57:
      if (tens_rec_by_derivatives) then
         call reconstruct_d57(coeffs)
      else
         call reconstruct3(numerator_d57, coeffs%coeffs_57)
      end if
   !------#] Diagram 57:
   !------#[ Diagram 60:
      if (tens_rec_by_derivatives) then
         call reconstruct_d60(coeffs)
      else
         call reconstruct2(numerator_d60, coeffs%coeffs_60)
      end if
   !------#] Diagram 60:
   !------#[ Diagram 64:
      if (tens_rec_by_derivatives) then
         call reconstruct_d64(coeffs)
      else
         call reconstruct2(numerator_d64, coeffs%coeffs_64)
      end if
   !------#] Diagram 64:
end subroutine reconstruct_group5
!---#] subroutine reconstruct_group5:
!---#[ subroutine reconstruct_group6:
subroutine     reconstruct_group6(coeffs)
   use tens_rec
   use p0_dd_emnebardu_config
   use p0_dd_emnebardu_groups, only: tensrec_info_group6
   use p0_dd_emnebardu_d5h0l1, only: numerator_d5 => numerator_golem95
   use p0_dd_emnebardu_d5h0l1d, only: reconstruct_d5
   use p0_dd_emnebardu_d17h0l1, only: numerator_d17 => numerator_golem95
   use p0_dd_emnebardu_d17h0l1d, only: reconstruct_d17
   use p0_dd_emnebardu_d35h0l1, only: numerator_d35 => numerator_golem95
   use p0_dd_emnebardu_d35h0l1d, only: reconstruct_d35
   use p0_dd_emnebardu_d56h0l1, only: numerator_d56 => numerator_golem95
   use p0_dd_emnebardu_d56h0l1d, only: reconstruct_d56
   use p0_dd_emnebardu_d61h0l1, only: numerator_d61 => numerator_golem95
   use p0_dd_emnebardu_d61h0l1d, only: reconstruct_d61
   use p0_dd_emnebardu_d65h0l1, only: numerator_d65 => numerator_golem95
   use p0_dd_emnebardu_d65h0l1d, only: reconstruct_d65
   use p0_dd_emnebardu_d67h0l1, only: numerator_d67 => numerator_golem95
   use p0_dd_emnebardu_d67h0l1d, only: reconstruct_d67
   implicit none
   type(tensrec_info_group6), intent(out) :: coeffs
   !------#[ Diagram 5:
      if (tens_rec_by_derivatives) then
         call reconstruct_d5(coeffs)
      else
         call reconstruct3(numerator_d5, coeffs%coeffs_5)
      end if
   !------#] Diagram 5:
   !------#[ Diagram 17:
      if (tens_rec_by_derivatives) then
         call reconstruct_d17(coeffs)
      else
         call reconstruct2(numerator_d17, coeffs%coeffs_17)
      end if
   !------#] Diagram 17:
   !------#[ Diagram 35:
      if (tens_rec_by_derivatives) then
         call reconstruct_d35(coeffs)
      else
         call reconstruct2(numerator_d35, coeffs%coeffs_35)
      end if
   !------#] Diagram 35:
   !------#[ Diagram 56:
      if (tens_rec_by_derivatives) then
         call reconstruct_d56(coeffs)
      else
         call reconstruct3(numerator_d56, coeffs%coeffs_56)
      end if
   !------#] Diagram 56:
   !------#[ Diagram 61:
      if (tens_rec_by_derivatives) then
         call reconstruct_d61(coeffs)
      else
         call reconstruct2(numerator_d61, coeffs%coeffs_61)
      end if
   !------#] Diagram 61:
   !------#[ Diagram 65:
      if (tens_rec_by_derivatives) then
         call reconstruct_d65(coeffs)
      else
         call reconstruct2(numerator_d65, coeffs%coeffs_65)
      end if
   !------#] Diagram 65:
   !------#[ Diagram 67:
      if (tens_rec_by_derivatives) then
         call reconstruct_d67(coeffs)
      else
         call reconstruct2(numerator_d67, coeffs%coeffs_67)
      end if
   !------#] Diagram 67:
end subroutine reconstruct_group6
!---#] subroutine reconstruct_group6:
!---#[ subroutine reconstruct_group7:
subroutine     reconstruct_group7(coeffs)
   use tens_rec
   use p0_dd_emnebardu_config
   use p0_dd_emnebardu_groups, only: tensrec_info_group7
   use p0_dd_emnebardu_d1h0l1, only: numerator_d1 => numerator_golem95
   use p0_dd_emnebardu_d1h0l1d, only: reconstruct_d1
   use p0_dd_emnebardu_d7h0l1, only: numerator_d7 => numerator_golem95
   use p0_dd_emnebardu_d7h0l1d, only: reconstruct_d7
   use p0_dd_emnebardu_d8h0l1, only: numerator_d8 => numerator_golem95
   use p0_dd_emnebardu_d8h0l1d, only: reconstruct_d8
   use p0_dd_emnebardu_d11h0l1, only: numerator_d11 => numerator_golem95
   use p0_dd_emnebardu_d11h0l1d, only: reconstruct_d11
   use p0_dd_emnebardu_d13h0l1, only: numerator_d13 => numerator_golem95
   use p0_dd_emnebardu_d13h0l1d, only: reconstruct_d13
   use p0_dd_emnebardu_d19h0l1, only: numerator_d19 => numerator_golem95
   use p0_dd_emnebardu_d19h0l1d, only: reconstruct_d19
   use p0_dd_emnebardu_d51h0l1, only: numerator_d51 => numerator_golem95
   use p0_dd_emnebardu_d51h0l1d, only: reconstruct_d51
   use p0_dd_emnebardu_d52h0l1, only: numerator_d52 => numerator_golem95
   use p0_dd_emnebardu_d52h0l1d, only: reconstruct_d52
   use p0_dd_emnebardu_d55h0l1, only: numerator_d55 => numerator_golem95
   use p0_dd_emnebardu_d55h0l1d, only: reconstruct_d55
   use p0_dd_emnebardu_d62h0l1, only: numerator_d62 => numerator_golem95
   use p0_dd_emnebardu_d62h0l1d, only: reconstruct_d62
   use p0_dd_emnebardu_d63h0l1, only: numerator_d63 => numerator_golem95
   use p0_dd_emnebardu_d63h0l1d, only: reconstruct_d63
   use p0_dd_emnebardu_d69h0l1, only: numerator_d69 => numerator_golem95
   use p0_dd_emnebardu_d69h0l1d, only: reconstruct_d69
   implicit none
   type(tensrec_info_group7), intent(out) :: coeffs
   !------#[ Diagram 1:
      if (tens_rec_by_derivatives) then
         call reconstruct_d1(coeffs)
      else
         call reconstruct3(numerator_d1, coeffs%coeffs_1)
      end if
   !------#] Diagram 1:
   !------#[ Diagram 7:
      if (tens_rec_by_derivatives) then
         call reconstruct_d7(coeffs)
      else
         call reconstruct2(numerator_d7, coeffs%coeffs_7)
      end if
   !------#] Diagram 7:
   !------#[ Diagram 8:
      if (tens_rec_by_derivatives) then
         call reconstruct_d8(coeffs)
      else
         call reconstruct2(numerator_d8, coeffs%coeffs_8)
      end if
   !------#] Diagram 8:
   !------#[ Diagram 11:
      if (tens_rec_by_derivatives) then
         call reconstruct_d11(coeffs)
      else
         call reconstruct2(numerator_d11, coeffs%coeffs_11)
      end if
   !------#] Diagram 11:
   !------#[ Diagram 13:
      if (tens_rec_by_derivatives) then
         call reconstruct_d13(coeffs)
      else
         call reconstruct2(numerator_d13, coeffs%coeffs_13)
      end if
   !------#] Diagram 13:
   !------#[ Diagram 19:
      if (tens_rec_by_derivatives) then
         call reconstruct_d19(coeffs)
      else
         call reconstruct2(numerator_d19, coeffs%coeffs_19)
      end if
   !------#] Diagram 19:
   !------#[ Diagram 51:
      if (tens_rec_by_derivatives) then
         call reconstruct_d51(coeffs)
      else
         call reconstruct1(numerator_d51, coeffs%coeffs_51)
      end if
   !------#] Diagram 51:
   !------#[ Diagram 52:
      if (tens_rec_by_derivatives) then
         call reconstruct_d52(coeffs)
      else
         call reconstruct1(numerator_d52, coeffs%coeffs_52)
      end if
   !------#] Diagram 52:
   !------#[ Diagram 55:
      if (tens_rec_by_derivatives) then
         call reconstruct_d55(coeffs)
      else
         call reconstruct3(numerator_d55, coeffs%coeffs_55)
      end if
   !------#] Diagram 55:
   !------#[ Diagram 62:
      if (tens_rec_by_derivatives) then
         call reconstruct_d62(coeffs)
      else
         call reconstruct2(numerator_d62, coeffs%coeffs_62)
      end if
   !------#] Diagram 62:
   !------#[ Diagram 63:
      if (tens_rec_by_derivatives) then
         call reconstruct_d63(coeffs)
      else
         call reconstruct2(numerator_d63, coeffs%coeffs_63)
      end if
   !------#] Diagram 63:
   !------#[ Diagram 69:
      if (tens_rec_by_derivatives) then
         call reconstruct_d69(coeffs)
      else
         call reconstruct2(numerator_d69, coeffs%coeffs_69)
      end if
   !------#] Diagram 69:
end subroutine reconstruct_group7
!---#] subroutine reconstruct_group7:
end module p0_dd_emnebardu_golem95h0
