module     p0_dd_emnebardu_d55h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p0_dd_emnebardu/helicity1/d55h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d55
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd55h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      real(ki) :: t25
      real(ki) :: t26
      real(ki) :: t27
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t25 = dotproduct(k2, qshift)
      t1 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t2 = (spvak1k4(1)*qshift(1)-spvak1k4(2)*qshift(2)-spvak1k4(3)*qshift(3)-sp&
      &vak1k4(4)*qshift(4))
      t3 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t26 = dotproduct(k1, qshift)
      t4 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t5 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t27 = dotproduct(qshift, qshift)
      t6 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb55n25+t25*abb55n22+t1*t25*abb55n16+t1*t26*abb55n16+t&
         &1*t27*abb55n26+t1*t3*abb55n18+t1*t4*abb55n17+t2*t3*abb55n15+t25*t4*abb&
         &55n20+t25*t5*abb55n19+t26*t3*abb55n21+t26*t5*abb55n19+t27*t5*abb55n23+&
         &t3*t4*t6*abb55n14)
         return
      end if
      t7 = k2(iv1)
      t8 = spvak1k2(iv1)
      t9 = k1(iv1)
      t10 = qshift(iv1)
      t11 = t8*abb55n16
      t12 = spvak1k4(iv1)
      t13 = spvak3k2(iv1)
      t14 = t13*abb55n19
      t15 = spvak3k4(iv1)
      t16 = spvak6k2(iv1)
      t17 = spvak1k5(iv1)
      if(deg.eq.1) then
         numerator = (t11*t25+t11*t26+t14*t25+t14*t26+t7*abb55n22+t8*abb55n25+t1&
         &*t10*abb55n27+t1*t15*abb55n17+t1*t16*abb55n18+t1*t7*abb55n16+t1*t9*abb&
         &55n16+t10*t5*abb55n24+t12*t3*abb55n15+t13*t27*abb55n23+t15*t25*abb55n2&
         &0+t16*t2*abb55n15+t16*t26*abb55n21+t27*t8*abb55n26+t3*t8*abb55n18+t3*t&
         &9*abb55n21+t4*t7*abb55n20+t4*t8*abb55n17+t5*t7*abb55n19+t5*t9*abb55n19&
         &+t15*t3*t6*abb55n14+t16*t4*t6*abb55n14+t17*t3*t4*abb55n14)
         return
      end if
      t25 = d(iv1,iv2)
      t2 = spvak1k2(iv2)
      t11 = spvak3k2(iv2)
      t14 = spvak6k2(iv2)
      t18 = k1(iv2)
      t19 = spvak3k4(iv2)
      t20 = k2(iv2)
      t21 = qshift(iv2)
      t22 = t17*t19
      t23 = spvak1k5(iv2)
      t24 = t15*t23
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t1*t25*abb55n26+t25*t5*abb55n23)+spvak1k4(iv2)*t&
         &16*abb55n15+t10*t11*abb55n24+t10*t2*abb55n27+t11*t7*abb55n19+t11*t9*ab&
         &b55n19+t12*t14*abb55n15+t13*t18*abb55n19+t13*t20*abb55n19+t13*t21*abb5&
         &5n24+t14*t8*abb55n18+t14*t9*abb55n21+t15*t2*abb55n17+t15*t20*abb55n20+&
         &t16*t18*abb55n21+t16*t2*abb55n18+t18*t8*abb55n16+t19*t7*abb55n20+t19*t&
         &8*abb55n17+t2*t7*abb55n16+t2*t9*abb55n16+t20*t8*abb55n16+t21*t8*abb55n&
         &27+t22*t3*abb55n14+t24*t3*abb55n14+t14*t15*t6*abb55n14+t14*t17*t4*abb5&
         &5n14+t16*t19*t6*abb55n14+t16*t23*t4*abb55n14)
         return
      end if
      t26 = d(iv2,iv3)
      t27 = d(iv1,iv3)
      t1 = spvak6k2(iv3)
      t3 = spvak3k4(iv3)
      t4 = spvak1k5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak1k2(iv3)*t25*abb55n26+spvak3k2(iv3)*t25*abb&
         &55n23+t11*t27*abb55n23+t13*t26*abb55n23+t2*t27*abb55n26+t26*t8*abb55n2&
         &6)+t1*t22*abb55n14+t1*t24*abb55n14+t14*t15*t4*abb55n14+t14*t17*t3*abb5&
         &5n14+t16*t19*t4*abb55n14+t16*t23*t3*abb55n14)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d55:
   subroutine     reconstruct_d55(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_55:
      coeffs%coeffs_55%c0 = derivative(czip)
      coeffs%coeffs_55%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_55%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_55%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_55%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_55%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_55%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_55%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_55%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_55%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_55%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_55%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_55%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_55%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_55%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_55%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_55%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_55%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_55%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_55%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_55%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_55%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_55%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_55%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_55%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_55%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_55%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_55%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_55%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_55%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_55%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_55%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_55:
   end subroutine reconstruct_d55
!---#] subroutine reconstruct_d55:
end module p0_dd_emnebardu_d55h1l1d
