module     p3_ud_emnebaruu_abbrevd66h0
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh0
   implicit none
   private
   complex(ki), public :: abb66n1
   complex(ki), public :: abb66n2
   complex(ki), public :: abb66n3
   complex(ki), public :: abb66n4
   complex(ki), public :: rat2d66
   complex(ki), public :: abb66n6
   complex(ki), public :: abb66n7
   complex(ki), public :: abb66n8
   complex(ki), public :: abb66n9
   complex(ki), public :: abb66n10
   complex(ki), public :: abb66n11
   complex(ki), public :: abb66n12
   complex(ki), public :: abb66n13
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   real(ki) :: t10
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = t1*spak2k5*spak3k6*spbk2k1
      t10 = TR*TR
      t3 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t4 = NC*NC*t3
      t5 = c2*i_
      t6 = t5*spak2k5*spak3k6*spbk2k1
      t7 = NC*t3
      t8 = NC*c2*i_
      t9 = t8*spak2k5*spak3k6*spbk2k1
      abb66n1 = ((4.0_ki)*(t10*t2/t4*spbk6k4+t10/t3*t9*spbk6k4-(2.0_ki)*t10*t6/t&
      &7*spbk6k4))
      abb66n2 = ((4.0_ki)*((2.0_ki)*t10*t6/t7*spbk4k3-(t10/t3*t9*spbk4k3+t10*t2/&
      &t4*spbk4k3)))
      t1 = t1*spak3k6
      t2 = t5*spak3k6
      t5 = t8*spak3k6
      abb66n3 = ((4.0_ki)*((2.0_ki)*t10*t2/t7*spbk4k3-(t10/t3*t5*spbk4k3+t10*t1/&
      &t4*spbk4k3)))
      abb66n4 = ((4.0_ki)*(t10*t1/t4*spbk6k4+t10/t3*t5*spbk6k4-(2.0_ki)*t10*t2/t&
      &7*spbk6k4))
      rat2d66 = 0
      rat2 = rat2 + rat2d66
      abb66n6 = -(abb66n1)
      abb66n7 = abb66n4
      abb66n8 = abb66n3
      abb66n9 = abb66n2
      abb66n10 = abb66n1
      abb66n11 = -(abb66n2)
      abb66n12 = -(abb66n3)
      abb66n13 = -(abb66n4)
   end subroutine
end module p3_ud_emnebaruu_abbrevd66h0
