module     p3_ud_emnebaruu_abbrevd65h1
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh1
   implicit none
   private
   complex(ki), public :: abb65n1
   complex(ki), public :: abb65n2
   complex(ki), public :: abb65n3
   complex(ki), public :: abb65n4
   complex(ki), public :: abb65n5
   complex(ki), public :: abb65n6
   complex(ki), public :: rat2d65
   complex(ki), public :: abb65n8
   complex(ki), public :: abb65n9
   complex(ki), public :: abb65n10
   complex(ki), public :: abb65n11
   complex(ki), public :: abb65n12
   complex(ki), public :: abb65n13
   complex(ki), public :: abb65n14
   complex(ki), public :: abb65n15
   complex(ki), public :: abb65n16
   complex(ki), public :: abb65n17
   complex(ki), public :: abb65n18
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   real(ki) :: t16
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es12*c2*i_
      t16 = TR*TR
      t2 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t3 = NC*t2
      t4 = es12*c1*i_
      t5 = t16*t4*spak1k3*spak3k6*spbk4k3*spbk5k2
      t4 = t16*t4*spak1k6*spak3k6*spbk5k2*spbk6k4
      t6 = NC*NC*t2
      abb65n1 = ((8.0_ki)*(t16*t1/t3*spak1k6*spak3k6*spbk5k2*spbk6k4-t16*t1/t3*s&
      &pak1k3*spak3k6*spbk4k3*spbk5k2)+(4.0_ki)*(t5/t2+t5/t6-(t4/t6+t4/t2)))
      t1 = c2*i_
      t4 = t1*spak1k3*spak3k6*spbk4k3
      t5 = t16/t3*t4*spbk5k2
      t7 = t1*spak1k6*spak3k6
      t8 = t16/t3*t7*spbk5k2*spbk6k4
      t9 = c1*i_
      t10 = t9*spak1k3*spak3k6*spbk4k3
      t11 = t16*t10*spbk5k2
      t12 = t11/t2
      t13 = t9*spak1k6*spak3k6
      t14 = t16*t13*spbk5k2*spbk6k4
      t15 = t14/t2
      t11 = t11/t6
      t14 = t14/t6
      abb65n2 = ((16.0_ki)*(t5-t8)+(8.0_ki)*(t14+t15-(t12+t11)))
      abb65n3 = ((16.0_ki)*(t8-t5)+(8.0_ki)*(t11+t12-(t15+t14)))
      t5 = t16*t10*spbk5k1
      t8 = t16*t13*spbk5k1*spbk6k4
      t10 = t16*t9*spak2k3*spak3k6*spbk4k3*spbk5k2
      t11 = t16*t9*spak2k6*spak3k6*spbk5k2*spbk6k4
      abb65n4 = ((8.0_ki)*(t16/t3*t4*spbk5k1+t16*t1/t3*spak2k6*spak3k6*spbk5k2*s&
      &pbk6k4-(t16*t1/t3*spak2k3*spak3k6*spbk4k3*spbk5k2+t16/t3*t7*spbk5k1*spbk6&
      &k4))+(4.0_ki)*(t10/t2+t10/t6+t8/t2+t8/t6-(t5/t6+t5/t2+t11/t6+t11/t2)))
      t4 = t9*spak3k6
      t5 = t16*t4*spbk4k3
      t1 = t1*spak3k6
      abb65n5 = ((4.0_ki)*(t5/t2+t5/t6-t16*(2.0_ki)*t1/t3*spbk4k3))
      t4 = t16*t4*spbk6k4
      abb65n6 = ((4.0_ki)*(t16*(2.0_ki)*t1/t3*spbk6k4-(t4/t6+t4/t2)))
      rat2d65 = 0
      rat2 = rat2 + rat2d65
      abb65n8 = abb65n1
      abb65n9 = abb65n6
      abb65n10 = abb65n5
      abb65n11 = abb65n4
      abb65n12 = abb65n3
      abb65n13 = abb65n2
      abb65n14 = -(abb65n2)
      abb65n15 = -(abb65n3)
      abb65n16 = -(abb65n4)
      abb65n17 = -(abb65n5)
      abb65n18 = -(abb65n6)
   end subroutine
end module p3_ud_emnebaruu_abbrevd65h1
