module     p6_dubar_emnebarssbar_d27h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p6_dubar_emnebarssbar/helicity0/d27h0l1.f90
   ! generator: haggies (1.1)
   use p6_dubar_emnebarssbar_config, only: ki
   use p6_dubar_emnebarssbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p6_dubar_emnebarssbar_groups, only: &
!           & sign => diagram27_sign, shift => diagram27_shift
      use p6_dubar_emnebarssbar_globalsl1, only: epspow
      use p6_dubar_emnebarssbar_kinematics
      use p6_dubar_emnebarssbar_abbrevd27h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d27

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d27 = 0.0_ki
      d27 = (abb27n1+abb27n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)&
      &-Q(4)*spvak2k1(4))+abb27n3*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3&
      &k1(3)-Q(4)*spvak3k1(4))+abb27n4*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*s&
      &pvak2k5(3)-Q(4)*spvak2k5(4))+abb27n5*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(&
      &4)*k5(4))+abb27n5*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb27n6*(&
      &Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+abb27n7*(Q(1)*spvak3k5(1)-Q(&
      &2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+abb27n8*(Q(1)*spvak6k5(&
      &1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))+abb27n9*(Q(1)*spva&
      &k6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)))
      numerator = cmplx(real(d27, ki), aimag(d27), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p6_dubar_emnebarssbar_globalsl1, only: epspow
      use p6_dubar_emnebarssbar_kinematics
      use p6_dubar_emnebarssbar_abbrevd27h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d27

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d27 = 0.0_ki
      d27 = (abb27n1+abb27n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)&
      &-Q(4)*spvak2k1(4))+abb27n3*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3&
      &k1(3)-Q(4)*spvak3k1(4))+abb27n4*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*s&
      &pvak2k5(3)-Q(4)*spvak2k5(4))+abb27n5*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(&
      &4)*k5(4))+abb27n5*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb27n6*(&
      &Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+abb27n7*(Q(1)*spvak3k5(1)-Q(&
      &2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+abb27n8*(Q(1)*spvak6k5(&
      &1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))+abb27n9*(Q(1)*spva&
      &k6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)))

      numerator = cmplx(real(d27, ki), aimag(d27), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p6_dubar_emnebarssbar_d27h0l1
