module     p6_dubar_emnebarssbar_d4h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p6_dubar_emnebarssbar/helicity0/d4h0l1d.f90
   ! generator: haggies (1.1)
   use p6_dubar_emnebarssbar_config, only: ki
   use p6_dubar_emnebarssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d4
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p6_dubar_emnebarssbar_globalsl1, only: epspow
      use p6_dubar_emnebarssbar_kinematics
      use p6_dubar_emnebarssbar_abbrevd4h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb4n19
         return
      end if
      t1 = k1(iv1)
      t2 = k3(iv1)
      t3 = k4(iv1)
      t4 = spvak3k1(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb4n34+k5(iv1)*abb4n24+k6(iv1)*abb4n24+spvak2k5(i&
         &v1)*abb4n22+t1*abb4n33+t2*abb4n32+t3*abb4n32+t4*abb4n30+t5*abb4n31+t6*&
         &abb4n23)
         return
      end if
      t7 = spvak6k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb4n25+k1(iv2)*t6*abb4n27+k3(iv2)*t6*&
         &abb4n28+k4(iv2)*t6*abb4n28+spvak2k1(iv1)*t7*abb4n29+spvak2k1(iv2)*t6*a&
         &bb4n29+spvak2k4(iv1)*t7*abb4n21+spvak2k4(iv2)*t6*abb4n21+spvak3k1(iv2)&
         &*t6*abb4n20+spvak3k4(iv2)*t6*abb4n26+t1*t7*abb4n27+t2*t7*abb4n28+t3*t7&
         &*abb4n28+t4*t7*abb4n20+t5*t7*abb4n26)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d4:
   subroutine     reconstruct_d4(coeffs)
      use p6_dubar_emnebarssbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_4:
      coeffs%coeffs_4%c0 = derivative(czip)
      coeffs%coeffs_4%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_4%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_4%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_4%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_4%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_4%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_4%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_4%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_4%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_4%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_4%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_4%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_4%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_4%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_4:
   end subroutine reconstruct_d4
!---#] subroutine reconstruct_d4:
end module p6_dubar_emnebarssbar_d4h0l1d
