module     p7_dubar_emnebargg_d11h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d11h0l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram11_sign, shift => diagram11_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd11h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d11
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d11 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      d11 = (abb11n5+t1*abb11n12+t2*abb11n13+t3*abb11n14+t4*abb11n6+t5*abb11n8+a&
      &bb11n10*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb11n11*(Q(1)*k2(1)-Q(&
      &2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb11n16*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(&
      &2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+abb11n7*(Q(1)*spvak2k4(1)-Q(2)*spva&
      &k2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t1*t4*abb11n3+t2*t4*abb11n2+t3&
      &*t4*abb11n15+t4*t5*abb11n4+t4*abb11n17*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)&
      &-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t4*abb11n9*(Q(1)*spvak2k1(1)-Q(2)*spv&
      &ak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)))
      numerator = cmplx(real(d11, ki), aimag(d11), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd11h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d11
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d11 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      d11 = (abb11n5+t1*abb11n12+t2*abb11n13+t3*abb11n14+t4*abb11n6+t5*abb11n8+a&
      &bb11n10*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb11n11*(Q(1)*k2(1)-Q(&
      &2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb11n16*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(&
      &2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+abb11n7*(Q(1)*spvak2k4(1)-Q(2)*spva&
      &k2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t1*t4*abb11n3+t2*t4*abb11n2+t3&
      &*t4*abb11n15+t4*t5*abb11n4+t4*abb11n17*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)&
      &-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t4*abb11n9*(Q(1)*spvak2k1(1)-Q(2)*spv&
      &ak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)))

      numerator = cmplx(real(d11, ki), aimag(d11), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d11h0l1
