module     p7_dubar_emnebargg_d24h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d24h0l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d24
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd24h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb24n46
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k1(iv1)
      t7 = spvak5k6(iv1)
      t8 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb24n80+t2*abb24n71+t3*abb24n81+t4*abb24n79+t5*abb24n7&
         &0+t6*abb24n75+t7*abb24n78+t8*abb24n77)
         return
      end if
      t33 = d(iv1,iv2)
      t9 = k1(iv2)
      t10 = k6(iv2)
      t11 = k2(iv2)
      t12 = k5(iv2)
      t13 = spvak3k4(iv2)
      t14 = t1*t13
      t15 = spvak5k1(iv2)
      t16 = spvak5k6(iv2)
      t17 = spvak6k5(iv2)
      t18 = t5*t9
      t19 = t13*t4
      t20 = t10*t5
      t21 = t15*t5
      t22 = t16*t5
      t23 = t13*t6
      t24 = t13*t7
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t33*abb24n59+t1*t9*abb24n52+t10*t4*abb24n52)+t14&
         &*abb24n68+t18*abb24n68+t19*abb24n67+t20*abb24n67+t21*abb24n65+t22*abb2&
         &4n69+t23*abb24n65+t24*abb24n69+spvak2k4(iv1)*t17*abb24n61+spvak2k4(iv2&
         &)*t8*abb24n61+t1*t10*abb24n54+t1*t11*abb24n58+t1*t12*abb24n53+t1*t15*a&
         &bb24n63+t1*t16*abb24n48+t1*t17*abb24n50+t10*t2*abb24n57+t10*t3*abb24n5&
         &2+t10*t6*abb24n64+t10*t7*abb24n49+t10*t8*abb24n51+t11*t4*abb24n57+t11*&
         &t6*abb24n66+t11*t8*abb24n56+t12*t4*abb24n52+t12*t5*abb24n68+t12*t6*abb&
         &24n64+t12*t7*abb24n49+t12*t8*abb24n55+t13*t3*abb24n68+t13*t8*abb24n62+&
         &t15*t2*abb24n66+t15*t3*abb24n64+t15*t4*abb24n64+t15*t8*abb24n60+t16*t3&
         &*abb24n49+t16*t4*abb24n49+t16*t8*abb24n47+t17*t2*abb24n56+t17*t3*abb24&
         &n55+t17*t4*abb24n51+t17*t5*abb24n62+t17*t6*abb24n60+t17*t7*abb24n47+t2&
         &*t9*abb24n58+t3*t9*abb24n53+t4*t9*abb24n54+t6*t9*abb24n63+t7*t9*abb24n&
         &48+t8*t9*abb24n50)
         return
      end if
      t34 = d(iv2,iv3)
      t35 = d(iv1,iv3)
      t2 = k1(iv3)
      t3 = k6(iv3)
      t11 = spvak3k4(iv3)
      t12 = spvak5k1(iv3)
      t25 = spvak5k6(iv3)
      t26 = spvak6k5(iv3)
      t27 = spvak2k1(iv1)
      t28 = spvak2k1(iv2)
      t29 = spvak2k1(iv3)
      t30 = spvak2k6(iv1)
      t31 = spvak2k6(iv2)
      t32 = spvak2k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t34*abb24n85+t10*t35*abb24n86+t11*t33*abb24n7&
         &2+t12*t33*abb24n74+t13*t35*abb24n72+t15*t35*abb24n74+t16*t35*abb24n87+&
         &t17*t35*abb24n82+t2*t33*abb24n85+t25*t33*abb24n87+t26*t33*abb24n82+t3*&
         &t33*abb24n86+t34*t4*abb24n86+t34*t5*abb24n72+t34*t6*abb24n74+t34*t7*ab&
         &b24n87+t34*t8*abb24n82+t35*t9*abb24n85)+t14*t26*abb24n84+t18*t26*abb24&
         &n84+t19*t26*abb24n83+t20*t26*abb24n83+t21*t26*abb24n73+t22*t26*abb24n8&
         &8+t23*t26*abb24n73+t24*t26*abb24n88+t1*t11*t17*abb24n84+t10*t11*t8*abb&
         &24n83+t11*t15*t8*abb24n73+t11*t16*t8*abb24n88+t11*t17*t27*abb24n76+t11&
         &*t17*t30*abb24n89+t11*t17*t4*abb24n83+t11*t17*t6*abb24n73+t11*t17*t7*a&
         &bb24n88+t11*t28*t8*abb24n76+t11*t31*t8*abb24n89+t11*t8*t9*abb24n84+t12&
         &*t13*t8*abb24n73+t12*t17*t5*abb24n73+t13*t2*t8*abb24n84+t13*t25*t8*abb&
         &24n88+t13*t26*t27*abb24n76+t13*t26*t30*abb24n89+t13*t29*t8*abb24n76+t1&
         &3*t3*t8*abb24n83+t13*t32*t8*abb24n89+t17*t2*t5*abb24n84+t17*t25*t5*abb&
         &24n88+t17*t29*t5*abb24n76+t17*t3*t5*abb24n83+t17*t32*t5*abb24n89+t26*t&
         &28*t5*abb24n76+t26*t31*t5*abb24n89)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d24:
   subroutine     reconstruct_d24(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_24:
      coeffs%coeffs_24%c0 = derivative(czip)
      coeffs%coeffs_24%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_24%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_24%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_24%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_24%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_24%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_24%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_24%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_24%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_24%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_24%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_24%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_24%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_24%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_24%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_24%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_24%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_24%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_24%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_24%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_24%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_24%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_24%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_24%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_24%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_24%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_24%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_24%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_24:
   end subroutine reconstruct_d24
!---#] subroutine reconstruct_d24:
end module p7_dubar_emnebargg_d24h0l1d
