module     p7_dubar_emnebargg_d2h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d2h0l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d2
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd2h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb2n10*(spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak&
         &6k5(3)*qshift(3)-spvak6k5(4)*qshift(4))+abb2n11*(spvak2k1(1)*qshift(1)&
         &-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+ab&
         &b2n12*(spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(&
         &3)-spvak2k4(4)*qshift(4))+abb2n13*(spvak5k6(1)*qshift(1)-spvak5k6(2)*q&
         &shift(2)-spvak5k6(3)*qshift(3)-spvak5k6(4)*qshift(4))+abb2n14*dotprodu&
         &ct(k1, qshift)+abb2n15*dotproduct(k3, qshift)+abb2n15*dotproduct(k4, q&
         &shift)+abb2n16*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3&
         &)*qshift(3)-spvak3k4(4)*qshift(4))+abb2n17*(spvak3k1(1)*qshift(1)-spva&
         &k3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb2n14+k3(iv1)*abb2n15+k4(iv1)*abb2n15+spvak2k1(i&
         &v1)*abb2n11+spvak2k4(iv1)*abb2n12+spvak3k1(iv1)*abb2n17+spvak3k4(iv1)*&
         &abb2n16+spvak5k6(iv1)*abb2n13+spvak6k5(iv1)*abb2n10)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d2:
   subroutine     reconstruct_d2(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_2:
      coeffs%coeffs_2%c0 = derivative(czip)
      coeffs%coeffs_2%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_2%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_2%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_2%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_2:
   end subroutine reconstruct_d2
!---#] subroutine reconstruct_d2:
end module p7_dubar_emnebargg_d2h0l1d
