module     p7_dubar_emnebargg_d43h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d43h0l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d43
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd43h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      real(ki) :: t17
      real(ki) :: t18
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k3-k2+k6+k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t17 = dotproduct(k1, qshift)
      t18 = dotproduct(k5, qshift)
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t4 = (spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-sp&
      &vak3k5(4)*qshift(4))
      t5 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t6 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb43n21+t1*abb43n31+t17*abb43n34+t18*abb43n35+t2*abb43n33&
         &+t3*abb43n36+abb43n30*dotproduct(qshift, qshift)+abb43n32*dotproduct(k&
         &6, qshift)+abb43n37*(spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak&
         &2k6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb43n39*(spvak3k6(1)*qshift(1&
         &)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-spvak3k6(4)*qshift(4))+t&
         &1*t3*abb43n29+t17*t3*abb43n24+t18*t3*abb43n23+t2*t3*abb43n25+t3*t4*abb&
         &43n22+t3*t5*abb43n26+t3*t6*abb43n27+t3*t7*abb43n28)
         return
      end if
      t8 = k1(iv1)
      t9 = k5(iv1)
      t10 = spvak5k6(iv1)
      t11 = spvak6k1(iv1)
      t12 = spvak6k5(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak2k5(iv1)
      t15 = spvak3k1(iv1)
      t16 = spvak3k5(iv1)
      if(deg.eq.1) then
         numerator = (k6(iv1)*abb43n32+qshift(iv1)*abb43n38+spvak2k6(iv1)*abb43n&
         &37+spvak3k6(iv1)*abb43n39+t10*abb43n36+t11*abb43n31+t12*abb43n33+t8*ab&
         &b43n34+t9*abb43n35+t1*t10*abb43n29+t10*t17*abb43n24+t10*t18*abb43n23+t&
         &10*t2*abb43n25+t10*t4*abb43n22+t10*t5*abb43n26+t10*t6*abb43n27+t10*t7*&
         &abb43n28+t11*t3*abb43n29+t12*t3*abb43n25+t13*t3*abb43n28+t14*t3*abb43n&
         &26+t15*t3*abb43n27+t16*t3*abb43n22+t3*t8*abb43n24+t3*t9*abb43n23)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb43n30+k1(iv2)*t10*abb43n24+k5(iv2)*&
         &t10*abb43n23+spvak2k1(iv2)*t10*abb43n28+spvak2k5(iv2)*t10*abb43n26+spv&
         &ak3k1(iv2)*t10*abb43n27+spvak3k5(iv2)*t10*abb43n22+spvak6k1(iv2)*t10*a&
         &bb43n29+spvak6k5(iv2)*t10*abb43n25+t1*t11*abb43n29+t1*t12*abb43n25+t1*&
         &t13*abb43n28+t1*t14*abb43n26+t1*t15*abb43n27+t1*t16*abb43n22+t1*t8*abb&
         &43n24+t1*t9*abb43n23)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d43:
   subroutine     reconstruct_d43(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_43:
      coeffs%coeffs_43%c0 = derivative(czip)
      coeffs%coeffs_43%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_43%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_43%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_43%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_43%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_43%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_43%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_43%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_43%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_43%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_43%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_43%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_43%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_43%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_43:
   end subroutine reconstruct_d43
!---#] subroutine reconstruct_d43:
end module p7_dubar_emnebargg_d43h0l1d
