module     p7_dubar_emnebargg_d45h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d45h0l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram45_sign, shift => diagram45_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd45h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d45
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d45 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      d45 = (abb45n2+t1*abb45n3+t2*abb45n4+t3*abb45n6+t4*abb45n7+t5*abb45n8+abb4&
      &5n10*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb45n11*(Q(1)*spvak3k5(1)&
      &-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+abb45n5*(Q(1)*k5(1)-&
      &Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb45n9*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5&
      &(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*t5*abb45n12+t2*t5*abb45n18+t3*t&
      &5*abb45n17+t4*t5*abb45n16+t5*abb45n13*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-&
      &Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t5*abb45n14*(Q(1)*spvak3k1(1)-Q(2)*spv&
      &ak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t5*abb45n15*(Q(1)*spvak2k6(1)&
      &-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t5*abb45n19*(Q(1)*sp&
      &vak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))
      numerator = cmplx(real(d45, ki), aimag(d45), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd45h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d45
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d45 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      d45 = (abb45n2+t1*abb45n3+t2*abb45n4+t3*abb45n6+t4*abb45n7+t5*abb45n8+abb4&
      &5n10*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb45n11*(Q(1)*spvak3k5(1)&
      &-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+abb45n5*(Q(1)*k5(1)-&
      &Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb45n9*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5&
      &(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*t5*abb45n12+t2*t5*abb45n18+t3*t&
      &5*abb45n17+t4*t5*abb45n16+t5*abb45n13*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-&
      &Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t5*abb45n14*(Q(1)*spvak3k1(1)-Q(2)*spv&
      &ak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t5*abb45n15*(Q(1)*spvak2k6(1)&
      &-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t5*abb45n19*(Q(1)*sp&
      &vak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))

      numerator = cmplx(real(d45, ki), aimag(d45), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d45h0l1
