module     p7_dubar_emnebargg_d88h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity0/d88h0l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram88_sign, shift => diagram88_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd88h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d88
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d88 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t4 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t10 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = t5*abb88n50
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t14 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t15 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d88 = (abb88n1+t1*abb88n10+t10*abb88n9+t12*t6+t12*t7+t2*abb88n11+t3*abb88n&
      &13+t4*abb88n16+t5*abb88n25+t5*t5*abb88n49+t6*abb88n26+t6*t6*abb88n32+t7*a&
      &bb88n27+t8*abb88n4+t9*abb88n5+t1*t10*abb88n15+t1*t3*abb88n36+t1*t4*abb88n&
      &65+t1*t5*abb88n31+t1*t6*abb88n30+t1*t7*abb88n29+t1*t8*abb88n23+t1*t9*abb8&
      &8n72+t10*t3*abb88n28+t10*t5*abb88n48+t10*t6*abb88n51+t10*t9*abb88n17+t11*&
      &t3*abb88n42+t2*t3*abb88n37+t2*t4*abb88n69+t2*t5*abb88n33+t2*t6*abb88n34+t&
      &2*t7*abb88n35+t2*t9*abb88n74+t3*t4*abb88n66+t3*t5*abb88n55+t3*t6*abb88n38&
      &+t3*t7*abb88n28+t3*t8*abb88n12+t3*t9*abb88n73+t4*t5*abb88n68+t4*t6*abb88n&
      &67+t4*t8*abb88n2+t5*t8*abb88n8+t5*t9*abb88n75+t6*t7*abb88n47+t6*t8*abb88n&
      &7+t6*t9*abb88n76+t7*t8*abb88n6+t7*t9*abb88n18+t8*t9*abb88n3+t1*t10*t3*abb&
      &88n20+t1*t10*t9*abb88n64+t1*t11*t3*abb88n22+t1*t13*t3*abb88n57+t1*t14*t3*&
      &abb88n41+t1*t15*t3*abb88n80+t1*t3*t4*abb88n64+t1*t3*t5*abb88n21+t1*t3*t6*&
      &abb88n19+t1*t3*t7*abb88n20+t1*t3*t8*abb88n56+t1*t3*t9*abb88n59+t1*t5*t8*a&
      &bb88n54+t1*t5*t9*abb88n63+t1*t6*t8*abb88n53+t1*t7*t8*abb88n52+t1*t7*t9*ab&
      &b88n62+t13*t3*t8*abb88n24+t14*t2*t3*abb88n45+t14*t3*t5*abb88n44+t14*t3*t6&
      &*abb88n43+t15*t2*t3*abb88n77+t15*t3*t5*abb88n78+t15*t3*t6*abb88n79+t2*t3*&
      &t4*abb88n61+t3*t4*t5*abb88n60+t3*t4*t6*abb88n58+t3*t4*t8*abb88n14+t3*t5*t&
      &8*abb88n40+t3*t6*t8*abb88n39+t3*t8*abb88n46*(Q(1)*spvak2k5(1)-Q(2)*spvak2&
      &k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t4*t5*t8*abb88n70+t4*t6*t8*abb88&
      &n71+t1*t13*t3*t8*abb88n81)
      numerator = cmplx(real(d88, ki), aimag(d88), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd88h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d88
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d88 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t4 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t10 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = t5*abb88n50
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t14 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t15 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d88 = (abb88n1+t1*abb88n10+t10*abb88n9+t12*t6+t12*t7+t2*abb88n11+t3*abb88n&
      &13+t4*abb88n16+t5*abb88n25+t5*t5*abb88n49+t6*abb88n26+t6*t6*abb88n32+t7*a&
      &bb88n27+t8*abb88n4+t9*abb88n5+t1*t10*abb88n15+t1*t3*abb88n36+t1*t4*abb88n&
      &65+t1*t5*abb88n31+t1*t6*abb88n30+t1*t7*abb88n29+t1*t8*abb88n23+t1*t9*abb8&
      &8n72+t10*t3*abb88n28+t10*t5*abb88n48+t10*t6*abb88n51+t10*t9*abb88n17+t11*&
      &t3*abb88n42+t2*t3*abb88n37+t2*t4*abb88n69+t2*t5*abb88n33+t2*t6*abb88n34+t&
      &2*t7*abb88n35+t2*t9*abb88n74+t3*t4*abb88n66+t3*t5*abb88n55+t3*t6*abb88n38&
      &+t3*t7*abb88n28+t3*t8*abb88n12+t3*t9*abb88n73+t4*t5*abb88n68+t4*t6*abb88n&
      &67+t4*t8*abb88n2+t5*t8*abb88n8+t5*t9*abb88n75+t6*t7*abb88n47+t6*t8*abb88n&
      &7+t6*t9*abb88n76+t7*t8*abb88n6+t7*t9*abb88n18+t8*t9*abb88n3+t1*t10*t3*abb&
      &88n20+t1*t10*t9*abb88n64+t1*t11*t3*abb88n22+t1*t13*t3*abb88n57+t1*t14*t3*&
      &abb88n41+t1*t15*t3*abb88n80+t1*t3*t4*abb88n64+t1*t3*t5*abb88n21+t1*t3*t6*&
      &abb88n19+t1*t3*t7*abb88n20+t1*t3*t8*abb88n56+t1*t3*t9*abb88n59+t1*t5*t8*a&
      &bb88n54+t1*t5*t9*abb88n63+t1*t6*t8*abb88n53+t1*t7*t8*abb88n52+t1*t7*t9*ab&
      &b88n62+t13*t3*t8*abb88n24+t14*t2*t3*abb88n45+t14*t3*t5*abb88n44+t14*t3*t6&
      &*abb88n43+t15*t2*t3*abb88n77+t15*t3*t5*abb88n78+t15*t3*t6*abb88n79+t2*t3*&
      &t4*abb88n61+t3*t4*t5*abb88n60+t3*t4*t6*abb88n58+t3*t4*t8*abb88n14+t3*t5*t&
      &8*abb88n40+t3*t6*t8*abb88n39+t3*t8*abb88n46*(Q(1)*spvak2k5(1)-Q(2)*spvak2&
      &k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t4*t5*t8*abb88n70+t4*t6*t8*abb88&
      &n71+t1*t13*t3*t8*abb88n81)

      numerator = cmplx(real(d88, ki), aimag(d88), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d88h0l1
