module     p7_dubar_emnebargg_d22h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d22h1l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram22_sign, shift => diagram22_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd22h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d22
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d22 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = t2*t2
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      d22 = (abb22n1+t1*abb22n13+t2*abb22n15+t3*abb22n19+t4*abb22n20+t4*t4*abb22&
      &n26+t5*abb22n21+t5*t5*abb22n26+t6*abb22n3+t7*abb22n4+t8*abb22n8+t9*abb22n&
      &9+t1*t2*abb22n35+t1*t4*abb22n31+t1*t5*abb22n33+t1*t7*abb22n12+t1*t8*abb22&
      &n31+t1*t9*abb22n32+t2*t4*abb22n29+t2*t5*abb22n30+t2*t6*abb22n10+t2*t7*abb&
      &22n2+t2*t8*abb22n16+t2*t9*abb22n17+t2*abb22n11*(Q(1)*spvak2k4(1)-Q(2)*spv&
      &ak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t3*t6*abb22n18+t4*t5*abb22n22&
      &+t4*t6*abb22n7+t4*t8*abb22n26+t4*t9*abb22n25+t5*t6*abb22n5+t5*t8*abb22n23&
      &+t5*t9*abb22n24+t6*t8*abb22n5+t6*t9*abb22n6+t1*t2*t6*abb22n34+t2*t4*t6*ab&
      &b22n27+t2*t5*t6*abb22n28+t2*t6*abb22n14*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2&
      &)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)))
      numerator = cmplx(real(d22, ki), aimag(d22), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd22h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d22
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d22 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = t2*t2
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      d22 = (abb22n1+t1*abb22n13+t2*abb22n15+t3*abb22n19+t4*abb22n20+t4*t4*abb22&
      &n26+t5*abb22n21+t5*t5*abb22n26+t6*abb22n3+t7*abb22n4+t8*abb22n8+t9*abb22n&
      &9+t1*t2*abb22n35+t1*t4*abb22n31+t1*t5*abb22n33+t1*t7*abb22n12+t1*t8*abb22&
      &n31+t1*t9*abb22n32+t2*t4*abb22n29+t2*t5*abb22n30+t2*t6*abb22n10+t2*t7*abb&
      &22n2+t2*t8*abb22n16+t2*t9*abb22n17+t2*abb22n11*(Q(1)*spvak2k4(1)-Q(2)*spv&
      &ak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t3*t6*abb22n18+t4*t5*abb22n22&
      &+t4*t6*abb22n7+t4*t8*abb22n26+t4*t9*abb22n25+t5*t6*abb22n5+t5*t8*abb22n23&
      &+t5*t9*abb22n24+t6*t8*abb22n5+t6*t9*abb22n6+t1*t2*t6*abb22n34+t2*t4*t6*ab&
      &b22n27+t2*t5*t6*abb22n28+t2*t6*abb22n14*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2&
      &)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)))

      numerator = cmplx(real(d22, ki), aimag(d22), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d22h1l1
