module     p7_dubar_emnebargg_d90h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity1/d90h1l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram90_sign, shift => diagram90_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd90h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d90
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d90 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = t1*t1
      t7 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t11 = t3*abb90n30
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d90 = (abb90n1+t1*abb90n13+t11*t2+t11*t7+t2*abb90n17+t3*abb90n18+t3*t3*abb&
      &90n29+t4*abb90n19+t5*abb90n2+t6*abb90n32+t7*abb90n4+t8*abb90n42+t9*abb90n&
      &5+t1*t10*abb90n15+t1*t12*abb90n35+t1*t13*abb90n43+t1*t2*abb90n23+t1*t3*ab&
      &b90n26+t1*t4*abb90n25+t1*t5*abb90n3+t1*t7*abb90n22+t1*t8*abb90n52+t1*t9*a&
      &bb90n24+t10*t6*abb90n11+t12*t6*abb90n36+t13*t2*abb90n44+t13*t3*abb90n45+t&
      &13*t4*abb90n46+t13*t6*abb90n59+t2*t5*abb90n20+t2*t6*abb90n7+t2*t7*abb90n2&
      &7+t3*t4*abb90n28+t3*t5*abb90n21+t3*t6*abb90n6+t3*t8*abb90n50+t4*t5*abb90n&
      &20+t4*t7*abb90n31+t5*t6*abb90n14+t5*t7*abb90n12+t5*t8*abb90n47+t6*t7*abb9&
      &0n7+t6*t8*abb90n37+t6*abb90n16*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*sp&
      &vak2k4(3)-Q(4)*spvak2k4(4))+t6*abb90n39*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2&
      &)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+t7*t8*abb90n49+t8*t9*abb90n51+t1*t10&
      &*t3*abb90n9+t1*t10*t5*abb90n34+t1*t10*t7*abb90n10+t1*t10*t9*abb90n8+t1*t1&
      &2*t5*abb90n48+t1*t13*t2*abb90n56+t1*t13*t3*abb90n54+t1*t13*t4*abb90n55+t1&
      &*t13*t7*abb90n57+t1*t13*t9*abb90n53+t1*t2*t5*abb90n33+t1*t3*t5*abb90n33+t&
      &1*t3*t8*abb90n40+t1*t4*t5*abb90n33+t1*t5*t7*abb90n33+t1*t5*t8*abb90n58+t1&
      &*t7*t8*abb90n38+t1*t8*t9*abb90n41+t12*t5*t6*abb90n60)
      numerator = cmplx(real(d90, ki), aimag(d90), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd90h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d90
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d90 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = t1*t1
      t7 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t11 = t3*abb90n30
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d90 = (abb90n1+t1*abb90n13+t11*t2+t11*t7+t2*abb90n17+t3*abb90n18+t3*t3*abb&
      &90n29+t4*abb90n19+t5*abb90n2+t6*abb90n32+t7*abb90n4+t8*abb90n42+t9*abb90n&
      &5+t1*t10*abb90n15+t1*t12*abb90n35+t1*t13*abb90n43+t1*t2*abb90n23+t1*t3*ab&
      &b90n26+t1*t4*abb90n25+t1*t5*abb90n3+t1*t7*abb90n22+t1*t8*abb90n52+t1*t9*a&
      &bb90n24+t10*t6*abb90n11+t12*t6*abb90n36+t13*t2*abb90n44+t13*t3*abb90n45+t&
      &13*t4*abb90n46+t13*t6*abb90n59+t2*t5*abb90n20+t2*t6*abb90n7+t2*t7*abb90n2&
      &7+t3*t4*abb90n28+t3*t5*abb90n21+t3*t6*abb90n6+t3*t8*abb90n50+t4*t5*abb90n&
      &20+t4*t7*abb90n31+t5*t6*abb90n14+t5*t7*abb90n12+t5*t8*abb90n47+t6*t7*abb9&
      &0n7+t6*t8*abb90n37+t6*abb90n16*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*sp&
      &vak2k4(3)-Q(4)*spvak2k4(4))+t6*abb90n39*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2&
      &)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+t7*t8*abb90n49+t8*t9*abb90n51+t1*t10&
      &*t3*abb90n9+t1*t10*t5*abb90n34+t1*t10*t7*abb90n10+t1*t10*t9*abb90n8+t1*t1&
      &2*t5*abb90n48+t1*t13*t2*abb90n56+t1*t13*t3*abb90n54+t1*t13*t4*abb90n55+t1&
      &*t13*t7*abb90n57+t1*t13*t9*abb90n53+t1*t2*t5*abb90n33+t1*t3*t5*abb90n33+t&
      &1*t3*t8*abb90n40+t1*t4*t5*abb90n33+t1*t5*t7*abb90n33+t1*t5*t8*abb90n58+t1&
      &*t7*t8*abb90n38+t1*t8*t9*abb90n41+t12*t5*t6*abb90n60)

      numerator = cmplx(real(d90, ki), aimag(d90), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d90h1l1
