module     p7_dubar_emnebargg_d25h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm2jets/1.4/Virtual
   ! /p7_dubar_emnebargg/helicity3/d25h3l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram25_sign, shift => diagram25_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd25h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d25
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3+k2-k6-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d25 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t3 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t6 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))
      t7 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t8 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t9 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      d25 = (t1*abb25n2+t1*t10*abb25n3+t1*t2*abb25n22+t1*t5*abb25n12+t1*t6*abb25&
      &n13+t1*t8*abb25n4+t2*t3*abb25n1+t2*t4*abb25n20+t3*t5*abb25n15+t3*t6*abb25&
      &n16+t3*t7*abb25n17+t3*t8*abb25n18+t3*t9*abb25n21+t3*abb25n10*(Q(1)*k5(1)-&
      &Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+t3*abb25n6*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*&
      &k2(3)-Q(4)*k2(4))+t3*abb25n7*(Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spva&
      &k5k2(3)-Q(4)*spvak5k2(4))+t3*abb25n8*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q&
      &(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t3*abb25n9*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*&
      &k1(3)-Q(4)*k1(4))+t4*t5*abb25n11+t4*t6*abb25n14+t4*t8*abb25n5+t10*t3*t7*a&
      &bb25n19+t10*t3*t9*abb25n23)
      numerator = cmplx(real(d25, ki), aimag(d25), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd25h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d25
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3+k2-k6-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d25 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t3 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t6 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))
      t7 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t8 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t9 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      d25 = (t1*abb25n2+t1*t10*abb25n3+t1*t2*abb25n22+t1*t5*abb25n12+t1*t6*abb25&
      &n13+t1*t8*abb25n4+t2*t3*abb25n1+t2*t4*abb25n20+t3*t5*abb25n15+t3*t6*abb25&
      &n16+t3*t7*abb25n17+t3*t8*abb25n18+t3*t9*abb25n21+t3*abb25n10*(Q(1)*k5(1)-&
      &Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+t3*abb25n6*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*&
      &k2(3)-Q(4)*k2(4))+t3*abb25n7*(Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spva&
      &k5k2(3)-Q(4)*spvak5k2(4))+t3*abb25n8*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q&
      &(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t3*abb25n9*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*&
      &k1(3)-Q(4)*k1(4))+t4*t5*abb25n11+t4*t6*abb25n14+t4*t8*abb25n5+t10*t3*t7*a&
      &bb25n19+t10*t3*t9*abb25n23)

      numerator = cmplx(real(d25, ki), aimag(d25), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d25h3l1
